module Arbre where

{-- Arbres binaris amb arbres buits --}
data Arbre a = Node a (Arbre a) (Arbre a)
             | Abuit
    deriving (Show, Read)

abuit = Abuit

plantar x a1 a2 = Node x a1 a2

arrel (Node x _ _) = x

fe (Node _ a1 _) = a1
fd (Node _ _ a2) = a2

esbuit Abuit = True
esbuit (Node _ _ _)    = False

iguals Abuit Abuit = True
iguals (Node _ _ _) Abuit = False
iguals  Abuit (Node _ _ _) = False
iguals (Node x a1 a2) (Node y b1 b2) = x==y && (iguals a1 b1) && (iguals a2 b2)

instance Eq a => Eq (Arbre a) where 
  x == y                =  x `iguals` y

arrel (read "Node 3 (Node 2 Abuit (Node 1 Abuit Abuit)) Abuit")::(Arbre Int)